function pc_projection=pc_projection_GMM(means,alphas,mcovs,targetdim,data_in)

tolerance=1e-4; % We'll use this to check convergence. 
                % Choose it as small as you like 
maxiter = 100;  % max number of iterations in the pc projection. 
                % 100 is most of the times more than enough but feel free
                % to increase this, since we also have a convergence
                % criterion to terminate the iterations

[dim N] = size(data_in);
for index = 1:N,
    flag=0;
    x=data_in(:,index);
    [p,g,H,SI,G] = gmmpdf(x,alphas,means,mcovs);
    [V D]=eig(SI);
    [dummy indexsorted] = sort(diag(abs(D)),'descend');
    ConstrainedSpace = V(:,indexsorted(1:end-targetdim));
    for csindex = 1:size(ConstrainedSpace,2),
        direction = ConstrainedSpace(:,csindex);
        direction = direction * sign(direction'*g);
        ConstrainedSpace(:,csindex) = direction;
    end
    
    % In most of the cases we may actually skip the following if statement.
    % I'm not sure yet.
%     if abs(g'*H*g/(norm(g'*H)*norm(g'*H)))<0.01,
%         flag=1;
%         pc_projection(:,index)= x;
%     end
    
    if ~flag,
        for pciteration=1:maxiter,
            [p,g,H,SI,G] = gmmpdf(x,alphas,means,mcovs);
             [V D]=eig(SI);
    [dummy indexsorted] = sort(diag(abs(D)),'descend');
    ConstrainedSpace = V(:,indexsorted(1:end-targetdim));
            x_old = x;
            msupdate = (inv((G'*alphas)*SI))*(sum((repmat((G.*alphas)',dim,1).*(SI*means)),2));
            update=msupdate-x;
            for i=1:csindex,
                direction = ConstrainedSpace(:,csindex);
                x = x + direction *(direction'*update);
            end
            if abs(x_old-x)<tolerance,break;end
        end
    end
    pc_projection(:,index) = x;
end
% figure,
% plot(data_in(1,:),data_in(2,:),'.');
% hold on,
% plot(pc_projection(1,:),pc_projection(2,:),'.r');axis equal;
